VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "mbx"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'CLASS MODULE MESSAGE OR INPUT BOXES, mbx.

'There should be nothing here that is specific to any
'particular project except that,

'1 The use of the CANCEL button
'  requires a Public Boolean, 'canceled', in the main program.

' Philip Bolt, 2005
'Last updated: 18/8/05

Option Explicit
Option Compare Text

Private Const mb_maw As Integer = 8000  'Maximum message box width.
Private Const mb_miw As Integer = 4500  'Minimum message box width.
Private Const n_ctrl As Integer = 13    'Number of controls.

Private but_pos() As Integer            'Button position array.
Private wd As Integer                   'Screen width.

Private setup As Boolean                'Data set-up flag.
 
Private frm As Object                   'The message_box form object.
Private ctrl() As Object                'Control array.

'Object constructor.
'Run when the object is created.

Private Sub Class_Initialize()

    If Not setup Then
        set_up
        setup = True
    End If
    
End Sub

'Procedure name:    Class_Terminate()
'Run when a page is terminated.

Private Sub Class_Terminate()
 
End Sub

'Routine to set up data for the mesage_box form.
'Procedure name:    set_up

Private Sub set_up()

    Set frm = mesage_box

    ReDim ctrl(n_ctrl)              'Dimension the control array.
    Set ctrl(0) = frm.Command1      'Message box OK button.
    Set ctrl(1) = frm.Command2      'Message box CANCEL button.
    Set ctrl(2) = frm.Command4      'Message box YES button.
    Set ctrl(3) = frm.Command3      'Message box NO button.
    Set ctrl(4) = frm.Command5      'Message box ABORT button.
    Set ctrl(5) = frm.Command6      'Message box RETRY button.
    Set ctrl(6) = frm.Command7      'Message box IGNORE button.
    Set ctrl(7) = frm.Label1        'Message box text area.
    Set ctrl(8) = frm.mes_icon      'Message box form icon picture box.
    Set ctrl(9) = frm.Text1         'Message box Text box, (Input_box).
    Set ctrl(10) = frm.Image1(0)    'Message box Icon Image Boxes.
    Set ctrl(11) = frm.Image1(1)
    Set ctrl(12) = frm.Image1(2)
    Set ctrl(13) = frm.Image1(3)
    
    ReDim but_pos(2)                'Message box button positions.
    but_pos(0) = 300
    but_pos(1) = 1750
    but_pos(2) = 3200
    
    wd = Screen.Width               'Store the screen width for form placement.
      
End Sub

'Custom Message Box routine as Procedure.
'Procedure name:    message_box(txt, vb, Optional icon = 0, Optional ttl = "",
'                               Optional tp = 2000, Optional lft = 0)
'Parameter:         txt;    the text,
'                   vb;     display code,       0 = OK only, vbOKOnly
'                                               1 = OK & CANCEL, vbOKCancel
'                                               2 = ABORT, RETRY & IGNORE, vbAbortRetryIgnore
'                                               3 = YES, NO & CANCEL, vbYesNoCancel, and
'                                               4 = YES & NO, vbYesNo
'                                               5 = RETRY & CANCEL, vbRetryCancel

'                   icon;   the icon required,  0 = none,
'                                               16 = vbCritical,
'                                               32 = vbQuestion,
'                                               48 = vbExclamation or
'                                               64 = vbInformation
'                                               show the usual displays.
'                   ttl;    the title,
'                   tp;     the Top position,
'                   lft;    the Left position.
'
'NB     The icon graphics must be included in a distribution.

Public Sub message_box(txt, vb, Optional icon = 0, Optional ttl = "", Optional tp = 2000, Optional lft = 0)

    Dim sc As Single
    
    sc = mesage_box.scle_factor         'Read the current scale factor.

    set_up_msbox_but sc, vb             'Set up the buttons and
    set_up_msbox sc, txt, tp, lft, icon 'the box display.
    
    frm.Caption = ttl               'Add the form caption,
    ctrl(7).Caption = txt           'the text and
 
    frm.Show vbModal                'display the form.
   
End Sub

'Custom Message Box routine as function.
'Procedure name:    message_bx(txt, vb, Optional icon = 0, Optional ttl = "",
'                              Optional tp = 2000, Optional lft = 0)
'Parameter:         txt;    the text,
'                   vb;     display code, (see above),
'                   icon;   the icon required, (see above),
'                   ttl;    the title,
'                   tp;     the Top position,
'                   lft;    the Left position.

Public Function message_bx(txt, vb, Optional icon = 0, Optional ttl = "", Optional tp = 2000, Optional lft = 0)

    Dim sc As Single
    
    sc = mesage_box.scle_factor     'Read the current scale factor.

    set_up_msbox_but sc, vb             'Set up the buttons and
    set_up_msbox sc, txt, tp, lft, icon 'the box size.
    
    frm.Caption = ttl               'Add the form caption,
    ctrl(7).Caption = txt           'the text and
    frm.Show vbModal                'display the form.
    
    message_bx = mesage_box.response 'Return the value from the form code.

End Function

'Custom Input Box function.
'Function name: input_box(txt, Optional icon = 0, Optional ttl = "", Optional tp = 2000,
'                         Optional lft = 0)
'Parameter:         txt;    the text,
'                   icon;   the icon required, (see above),
'                   ttl;    the title,
'                   deflt;  the default value,
'                   tp;     the Top position,
'                   lft;    the Left position.

Public Function input_box(txt, Optional icon = 0, Optional ttl = "", Optional deflt = "", Optional tp = 2000, Optional lft = 0)
 
    Dim sc As Single
    
    sc = mesage_box.scle_factor         'Read the current scale factor.
 
    set_up_msbox_but sc, 1                  'Set up the OK and CANCEL buttons and
    set_up_msbox sc, txt, tp, lft, icon, 1  'the box size.
                  
    frm.Caption = ttl                   'Add the form caption,
    ctrl(7).Caption = txt               'the text and
    If deflt <> "" Then                 'the default value,
        ctrl(9).Text = deflt            'of any.
    End If
    
    ctrl(9).TabIndex = 0                'Set the tab to the Text box.
 
    frm.Show vbModal                    'display the form.
    
    input_box = mesage_box.response     'Return the value from the form code.

End Function

'Routine to set up the size, etc. of a message box form.
'Procedure name:    set_up_msbox(scl, tx, t, l, Optional con = 0, Optional typ = 0)
'Parameters;        scl;    the scale factor,
'                   tx;     the message text,
'                   t;      the Top position,
'                   l;      the Left position,
'                   con;    the icon,
'                   typ;    the type, 0=message_box or message_bx, 1=input_box.

Private Sub set_up_msbox(scl, tx, t, l, Optional con = 0, Optional typ = 0)
 
    Dim mt_ht, mt_wd, l_ht, l_wd, f_wd, f_ht, j, lf, t1, t2, t3 As Integer
 
    mt_ht = frm.TextHeight(tx)      'Read the height and
    mt_wd = frm.TextWidth(tx)       'width of the message text.
 
    l_ht = mt_ht + 240 * scl
    
    l_wd = mt_wd + 240 * scl        'Set the list box width and
    If l_wd < mb_miw * scl Then     'check it for the lower limit.
        l_wd = mb_miw * scl
    End If
    
    If l_wd > mb_maw * scl Then     'Check for the upper limit.
        l_wd = mb_maw * scl         'If it's over, set to the maximum and
        l_ht = l_ht + 240 * scl     'add an extra line space.
    End If
 
    f_wd = l_wd + 600 * scl + ctrl(8).Width 'Set the size of the form.

    If l = 0 Then               'If the Left parameter was ommited,
        lf = (wd - f_wd) / 2    'centre the form.
    Else                        'Otherwise,
        lf = l                  'set it to the parameter value.
    End If
    
    t1 = 200 * scl      'Define the top of the Label position and
    With ctrl(7)        'set the label.
        .Height = l_ht
        .Width = l_wd
        .Top = t1
    End With
    
    If typ = 0 Then                             'This is a message box, so
        t3 = t1 + ctrl(7).Height + 200 * scl    'define the button Top value and
        ctrl(9).Visible = False                 'hide the text Box.
    Else                                        'Otherwise, it's an input box, so
        t2 = t1 + ctrl(7).Height + 200 * scl    'define the Text Box Top and
        With ctrl(9)                            'size and position it.
            .Width = f_wd - 600 * scl
            .Height = 420 * scl
            .Top = t2
            .Left = (f_wd - .Width) / 2
            .Visible = True
        End With
        t3 = t2 + ctrl(9).Height + 200 + scl    'Define the button Top value.
    End If
 
    For j = 0 To 6          'Set the button Top positions
        ctrl(j).Top = t3    'to the same value for all the buttons.
    Next

    With frm    'Size and position the form.
        .Height = t3 + ctrl(0).Height + 200 * scl + 400 'The '400' is for the Caption depth.
        .Width = f_wd
        .Top = t
        .Left = lf
    End With
    
    If con <> 0 Then
        con = con / 16                          'Convert the icon value and
        ctrl(8).Picture = ctrl(9 + con).Picture 'add the graphic.
    Else                                        'or
        ctrl(8).Cls                             'clear the Picture Box.
    End If
    
End Sub

'Routine to set up the  message box buttons.
'Procedure name:    set_up_msbox_but(v, sc)
'Parameter:         scl;    the scale factor,
'                   v;      the button selection constant.

Private Sub set_up_msbox_but(scl, v)

    Dim j As Integer

    For j = 0 To 6
        ctrl(j).Visible = False   'Initially, switch off all buttons.
    Next
    
    Select Case v
        Case 0 'OK only
            With ctrl(0)
                .Left = but_pos(0) * scl
                .Visible = True
            End With
        Case 1 'OK & CANCEL
            With ctrl(0)
                .Left = but_pos(0) * scl
                .Visible = True
            End With
            With ctrl(1)
                .Left = but_pos(1) * scl
                .Visible = True
            End With
        Case 2 'ABORT, RETRY & IGNORE
            With ctrl(4)
                .Left = but_pos(0) * scl
                .Visible = True
            End With
            With ctrl(5)
                .Left = but_pos(1) * scl
                .Visible = True
            End With
            With ctrl(6)
                .Left = but_pos(2) * scl
                .Visible = True
            End With
        Case 3 'YES, NO & CANCEL
            With ctrl(1)
                .Left = but_pos(0) * scl
                .Visible = True
            End With
            With ctrl(2)
                .Left = but_pos(1) * scl
                .Visible = True
            End With
            With ctrl(3)
                .Left = but_pos(2) * scl
                .Visible = True
            End With
        Case 4 'YES & NO only
            With ctrl(2)
                .Left = but_pos(0) * scl
                .Visible = True
            End With
            With ctrl(3)
                .Left = but_pos(1) * scl
                .Visible = True
            End With
        Case 5 'RETRY & CANCEL
            With ctrl(5)
                .Left = but_pos(0) * scl
                .Visible = True
            End With
            With ctrl(3)
                .Left = but_pos(1) * scl
                .Visible = True
            End With
    End Select

End Sub

